#include <stdio.h>
#include <string.h>

#include "../const.h"
#include "Kconst.hpp"

#include "KINode.hpp"
#include "KTree.hpp"
#include "KLNode.hpp"

#ifndef NULL
#define NULL 0
#endif 

KLNode::KLNode(pKINode parent, pRect rect, pQuery q) : KNode(true, parent, rect)
{
	//-- init KLNode part --
	this->partQ = new DynArray<pQuery>();
	
	if (q == NULL) //e.i. root node
	{
		return;
	}
	
	partQ->insert(q);
}




//-----------------------------------------
void KLNode::add(pQuery q0)
{
	//-- is there space in the node --
	if (partQ->cur_sz < KNODE_MAX_POINTS)
	{
		partQ->insert(q0);
		return;
	}

	//-- need to split --

	//-- create new INode --
	pKINode inode = new KINode(parent, &rect);

	inode->add(q0);
	
	//-- add all partQ to INode --
	for (int i = 0; i < partQ->cur_sz; i++)
	{
		pQuery q = partQ->arr[i];

		inode->add(q);
	}

	delete partQ;

	memmove(this, inode, sizeof(KINode));
}





//------------------------------------
void KLNode::remove(pQuery q)
{
	partQ->remove(q);
}


