#include "KINode.hpp"
#include "KLNode.hpp"
#include "KNode.hpp"

//------------------------------------------------------
KNode::KNode(bool isLeaf, KINode *parent, pRect rect)
{
	this->isLeaf = isLeaf;
	this->parent = parent;
	this->rect   = *rect;

	fullQ = new DynArray<pQuery>();
}


//------------------------------------------------------
void KNode::add(pQuery q)
{
	//-- check if node is full in q --
	if (rect.x             >= q->x           &&
		rect.x + rect.x_sz <= q->x + q->x_sz &&
		rect.y             >= q->y           &&
		rect.y + rect.y_sz <= q->y + q->y_sz)
	{
		fullQ->insert(q);
		return;
	}

	if (isLeaf)
	{
		pKLNode lnode = (pKLNode)this;
		lnode->add(q);
		return;
	}

	pKINode inode = (pKINode)this;
	inode->add(q);
}

